"use strict";
// import * as program from 'commander';
var program = require("../../libnpm/commander");
const project = require('../nest/project');
const config = require('../nest/config');
const utils = require('../nest/utils');
const file = require('fs-extra-promise');
const path = require('path');
var result = program.usage("[relativePath] | <absolutePath>")
    .option("-p, --path <absoluatePath>", "nestPath")
    .option("-a, --autoCompile [bool]", "auto Build In egret")
    .parse(process.argv);
// console.log("I am egret-cli-nest-run");
// console.log(program);
function run() {
    let nestPath = null;
    let absolutePath = program['path'];
    let relativePath = (process.argv[2] && process.argv[2].indexOf('-') == -1) ? process.argv[2] : null;
    if (absolutePath || relativePath) {
        if (absolutePath) {
            if (file.existsSync(absolutePath)) {
                nestPath = absolutePath;
            }
            else {
                console.error(`path ${absolutePath} don't exist!`);
                return;
            }
        }
        else {
            nestPath = path.join(process.cwd(), relativePath);
        }
    }
    else {
        nestPath = process.cwd();
    }
    if (nestPath) {
        let configObj = config.read(nestPath);
        if (configObj) {
            if (utils.isEmptyObject(configObj)) {
                console.error(`You should cd ${nestPath} then execute 'egret-cli nest set' first!`);
                return;
            }
            project.run(nestPath, configObj, program['autoCompile']);
        }
    }
}
run();
//# sourceMappingURL=egret-cli-nest-run.js.map