"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const fs = require('fs-extra-promise');
const config = require('../config');
const util_1 = require('../util');
const path = require("path");
function run(deployConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        var args = [
            "build",
            config.egretProjectPath,
            "-e",
            "--runtime",
            "native"
        ];
        // let android_path = await config.getConfig(config.KEY.ANDROID_PROJECT_PATH);
        let android_path = deployConfig.androidProjectPath;
        let egret_game_android_path = path.resolve(config.egretProjectPath, android_path, "assets/egret-game");
        let egret_game_android_path_polyfill = path.resolve(config.egretProjectPath, android_path, "proj.android/assets/egret-game");
        let shellCommand = process.platform == "win32" ? "egret.cmd" : "egret";
        yield util_1.shell(shellCommand, args, {});
        yield fs.removeAsync(egret_game_android_path);
        yield fs.moveAsync(egret_game_android_path_polyfill, egret_game_android_path);
        yield fs.removeAsync(egret_game_android_path_polyfill);
        if (deployConfig.sdk) {
            let android_sdk_path = path.resolve(config.egretProjectPath, android_path, `../${path.basename(android_path)}.${deployConfig.sdk}`);
            // let android_sdk_path = config.getConfig(`android-sdk-${deployConfig.sdk}-path`);
            let egret_game_android_sdk_path = path.resolve(android_sdk_path, "assets/egret-game");
            yield fs.copyAsync(egret_game_android_path, egret_game_android_sdk_path);
        }
    });
}
exports.run = run;
//# sourceMappingURL=deploy.js.map