"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const config = require('../config');
const path = require("path");
const util_1 = require("../util");
function run(releaseConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        let android_path = releaseConfig.androidProjectPath;
        android_path = path.resolve(config.egretProjectPath, android_path);
        let sdk = releaseConfig.sdk;
        yield upgradeAntBuildXML("EgretGame", android_path);
        yield upgradeAntBuildXML(`EgretGame.${sdk}`, `${android_path}.${sdk}`);
        let ant_dir = yield config.getConfig(config.KEY.ANT_DIR_PATH);
        let ant = path.join(ant_dir, "ant");
        yield util_1.shell(ant, ["debug"], { cwd: `${android_path}.${sdk}` });
    });
}
exports.run = run;
function upgradeAntBuildXML(name, android_path) {
    return __awaiter(this, void 0, void 0, function* () {
        let android_sdk = yield config.getConfig(config.KEY.ANDROID_SDK);
        let android_command = path.join(android_sdk, "tools/android");
        let args = ["update", "project", "--name", name, "--target", "android-19", "--path", android_path];
        yield util_1.shell(android_command, args, {});
    });
}
//# sourceMappingURL=release.js.map