"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const ast = require('egret-typescript-ast');
const path = require('path');
function run(egretRoot) {
    return __awaiter(this, void 0, void 0, function* () {
        let decorators = yield ast.findDecorator(path.join(egretRoot, "src/Main.ts"));
        decorators = decorators.filter(item => item.name == "RES.mapConfig");
        let resourceConfigFileFileName = "";
        let resourceRoot = "resource/";
        if (!decorators || !decorators.length) {
            resourceConfigFileFileName = "config.resjs";
        }
        else {
            let resourceFileNames = decorators.map(item => item.paramters[0]);
            resourceConfigFileFileName = resourceFileNames[0];
        }
        let resConfigFilePath = path.join(resourceRoot, resourceConfigFileFileName);
        return { resourceRoot: resourceRoot, resourceConfigFileFileName: resourceConfigFileFileName };
    });
}
exports.run = run;
//# sourceMappingURL=config.js.map